#!/bin/sh

if [ $# -ne 1 ] ; then
    echo "" 
    exit 1
fi

## FLAGS_READ_XATTR         std::os::raw::c_int   0x0001
## FLAGS_WRITE_XATTR        std::os::raw::c_int   0x0002
## FLAGS_CLEAR_XATTR        std::os::raw::c_int   0x0004
## FLAGS_MAX_AGE            std::os::raw::c_int   0x0008
## FLAGS_NULL_TERMINATED    std::os::raw::c_int   0x0010
## FLAGS_QUIET              std::os::raw::c_int   0x0000
## FLAGS_VERBOSE0           std::os::raw::c_int   0x0000
## FLAGS_VERBOSE1           std::os::raw::c_int   0x0020
## FLAGS_VERBOSE2           std::os::raw::c_int   0x0040
## FLAGS_VERBOSE3           std::os::raw::c_int   0x0060

gen_h() {
    echo "enum {"
    (grep '^##' $0 | sed -re 's/[ \t]+/ /g' | cut -d' ' -f 2-) \
        | while read -r flag type value ; do
        echo "  ${flag}=${value},"
    done
    echo "};"
}

gen_rs() {
    echo "use std;"
    echo
    (grep '^##' $0 | sed -re 's/[ \t]+/ /g' | cut -d' ' -f 2-) \
        | while read -r flag type value ; do
        echo "#[allow(dead_code)]"
        echo "pub const ${flag} : ${type} = ${value};"
    done
}



case $1 in
    --h)
        gen_h 
        ;;
    --rs)
        gen_rs
        ;;
    *)
        exit 1
        ;;
esac
